use super::PlayerAgent;
use crate::util::Symb;
use rand::Rng;
use std::num::NonZeroU8;

pub struct RandomAgent {}

impl PlayerAgent for RandomAgent {
	fn step(&mut self, board: &mut crate::board::Board) {
		let mut rng = rand::thread_rng();
		let n = board.size();

		let mut c = rng.gen_range(0..n);
		let mut s = match rng.gen_range(0..4) {
			0 => {
				let n = rng.gen_range(0..=9);
				if n == 0 {
					Symb::Zero
				} else {
					Symb::Number(NonZeroU8::new(n).unwrap())
				}
			}
			1 => Symb::Div,
			2 => Symb::Minus,
			3 => Symb::Plus,
			4 => Symb::Times,
			_ => unreachable!(),
		};

		while !board.play(c, s) {
			c = rng.gen_range(0..n);
			s = match rng.gen_range(0..4) {
				0 => {
					let n = rng.gen_range(0..=9);
					if n == 0 {
						Symb::Zero
					} else {
						Symb::Number(NonZeroU8::new(n).unwrap())
					}
				}
				1 => Symb::Div,
				2 => Symb::Minus,
				3 => Symb::Plus,
				4 => Symb::Times,
				_ => unreachable!(),
			};
		}
	}
}
